{ UNIT zur Codierung der Tokenliste in ALI ............................................................... <CODER.PAS> }
{                                                                                                                      }
{ Die Tokenliste und die Symboltabelle werden vom Objekt TCompiler bereitgestellt.                                     }
{                                                                                                                      }
{ Die zugrunde liegende Grammatik: ................................................................................... }
{                                                                                                                      }
{  S         ::= programm name trennung BLOCK                                                                          }
{  BLOCK     ::= start ANWFOLG ende                                                                                    }
{  ANWFOLG   ::= ANWEISUNG | ANWEISUNG trennung ANWFOLG                                                                }
{  ANWEISUNG ::= ZUWEISUNG | BLOCK | LIESANW | SCHREIBANW | WENNANW | SOLANGEANW | WDHANW                              }
{  LIESANW   ::= lies klammerauf name klammerzu                                                                        }
{  SCHREIBANW::= schreib klammerauf AUSDRUCK klammerzu                                                                 }
{  SOLANGEANW::= solange BEDAUSDR tue ANWEISUNG                                                                        }
{  WDHANW    ::= wiederhole ANWFOLG bis BEDTERAUSD                                                                     }
{  WENNANW   ::= wenn BEDAUSDR dann ANWEISUNG (sonst ANWEISUNG)                                                        }
{  BEDAUSDR  ::=  BEDTERM ( oder BEDTERM )*           * heisst beliebig oft                                            }
{  BEDTERM   ::=  VERGLEICH ( oder VERGLEICH )*                                                                        }
{  VERGLEICH ::= AUSDRUCK vergloperator AUSDRUCK                                                                       }
{  ZUWEISUNG ::= name zuweisungsop AUSDRUCK                                                                            }
{  AUSDRUCK  ::= TERM | TERM strichoperator AUSDRUCK                                                                   }
{  TERM      ::= FAKTOR | FAKTOR punktoperator TERM                                                                    }
{  FAKTOR    ::= name | zahl | klammerauf AUSDRUCK klammerzu                                                           }
{                                                                                                                      }
{                                                                                       Version 5 / 2002 / Ga / Lk12.2 }
{ -------------------------------------------------------------------------------------------------------------------- }

unit Coder;

interface


  uses u_types, u_adt;                                                    { Die Symboltabelle ist ntig, um            }
                                                                          { Hilfsvariablen zur Symboltabelle           }
                                                                          { hinzuzufgen (Drei-Adress-Format           }

(*
{ Fr DOS-ALI: }
  const INI : string= 'INI';                                              { Da DOS-ALI und WIN-ALI unterschiedliche    }
        OUTI: string= 'OUTI';                                             { Befehlsstze haben, werden Konstanten      }
        LDA : string= 'L';                                                { verwendet.                                 }
        STA : string= 'ST';
        MUL : string= 'M';
        DIF : string= 'D';
        ADD : string= 'A';
        SUB : string= 'S';
        CMP : string= 'C';
*)

{ Fr WIN-ALI: }
  const INI : string= 'INI';
        OUTI: string= 'OUTI';
        LDA : string= 'LDA';
        STA : string= 'STA';
        MUL : string= 'MUL';
        DIF : string= 'DIV';
        ADD : string= 'ADD';
        SUB : string= 'SUB';
        CMP : string= 'CMP';


  type
       TMarke = string[8];                                                { String-Definitionen                        }
       TBefehl = string[8];
       TOperand = string[14];
       TKommentar = string[60];

       TAliprogrammEintrag = class(TElement)                              { Ali-Programmzeile als Listenelement        }
          public
            marke: TMarke;
            Befehl: TBefehl;
            Operand: TOperand;
            Kommentar: TKommentar;
            constructor create(m: TMarke; b: TBefehl; o: TOperand; k: TKommentar);
        end;

       TAliprogramm= class(TLinList)
         public
         procedure add(m: TMarke; b: TBefehl; o: TOperand; k: TKommentar);{ Neue Befehlszeile anhngen                 }
       end;

       TCoder = class                                                     { Der Coder realisiert als Klasse            }
         private
         Symboltabelle: TSymboltabelle;                                   { wird beim Zerlegungsalgorithmus verndert  }
         Tokenliste: TTokenliste;                                         { bleibt so wie sie ist                      }
         otk, odk: TStack;                                                { vom Typ integer = TSymbolIndex             }
         HCounter, MCounter: integer;                                     { Zhler fr Hilfsvariablen und Sprungmarken }


         function NextSprungmarke: string;                                { liefert eine neue Sprungmarke Mxxx         }
         function NextHilfsvariable: string;                              { liefert eine neue Hilfsvariable Hxxx       }

         procedure werte_aus(var invariable: string);

         procedure S ( var AktuellerTokenIndex: TSymbolIndex ) ;          { und auch die Grammatik muss bekannt sein   }
          procedure BLOCK (var AktuellerTokenIndex: TSymbolIndex ) ;
           procedure ANWFOLG (var AktuellerTokenIndex: TSymbolIndex ) ;
            procedure ANWEISUNG (var AktuellerTokenIndex: TSymbolIndex ) ;
             procedure LIESANW (var AktuellerTokenIndex: TSymbolIndex ) ;
             procedure SCHREIBANW (var AktuellerTokenIndex: TSymbolIndex ) ;
             procedure WDHANW (var AktuellerTokenIndex: TSymbolIndex ) ;
             procedure SOLANGEANW (var AktuellerTokenIndex: TSymbolIndex ) ;
             procedure WENNANW (var AktuellerTokenIndex: TSymbolIndex ) ;
              procedure BEDAUSDR (var AktuellerTokenIndex: TSymbolIndex; Smarke: string; Test_auf: boolean ) ;
               procedure BEDTERM (var AktuellerTokenIndex: TSymbolIndex; Smarke: string; Test_auf: boolean ) ;
                procedure VERGLEICH (var AktuellerTokenIndex: TSymbolIndex; Smarke: string; Test_auf: boolean ) ;
             procedure ZUWEISUNG (var AktuellerTokenIndex: TSymbolIndex ) ;
              procedure AUSDRUCK (var AktuellerTokenIndex: TSymbolIndex; var invariable: string ) ;
               procedure TERM (var AktuellerTokenIndex: TSymbolIndex; var invariable: string ) ;
                procedure FAKTOR (var AktuellerTokenIndex: TSymbolIndex; var invariable: string ) ;

         public
         Aliprogramm: TAliprogramm;
         constructor create(TL: TTokenliste; var ST: TSymboltabelle);     { Symboltabelle: schreibend, TL: lesend      }
         destructor destroy;
         procedure Code;                                                  { Codiert die Tokenliste in ALI              }
       end;


implementation


{ Operationen zur Bearbeitung der ALI-Tabelle .................................}

constructor TAliprogrammEintrag.create(m: TMarke; b: TBefehl; o: TOperand; k: TKommentar);
begin
  inherited create;
  Marke:= m;
  Befehl:= b;
  Operand:= o;
  Kommentar:= k;
end;

procedure TAliprogramm.add(m: TMarke; b: TBefehl; o: TOperand; k: TKommentar);
begin
  EinfuegenNach(TAliProgrammEintrag.Create(m,b,o,k));
end;


function TCoder.NextSprungmarke: string;                                   { liefert eine neue Sprungmarke Mxxx        }
var m: string;
begin
  inc(MCounter);
  str(MCounter, m);
  m:= 'M'+m;
  NextSprungmarke:= m;
end;

function TCoder.NextHilfsvariable: string;                                 { liefert eine neue Hilfsvariable Hxxx      }
var h: string;
begin
  inc(HCounter);
  str(HCounter, h);
  h:= 'h'+h;
  NextHilfsvariable:= h;
end;

{ Operationen fr die Zerlegung arithmetischer Ausdrcke ............................................................. }

function Prioritaet(ot: TSymbol): byte;                                    { Hilfsroutine fr die werte_aus            }
begin
  case ot of
    ZUWEISUNGsop,klammerauf  : Prioritaet:= 0;
    strichoperator           : Prioritaet:= 1;
    punktoperator            : Prioritaet:= 2;
  end;
end;

procedure TCoder.werte_aus(var invariable: string);
                                                                           { Die Keller-Auswertungsroutine aus den     }
                                                                           { gelben Heften, leicht abgewandelt.        }
                                                                           { invariable gibt den Variablennamen        }
                                                                           { aus, auf den im Dreiadressformat          }
                                                                           { gespeichert wurde.                        }
var od1, od2, ot, neuerod: TSymbolIndex;                                   { Operanden und Operator als SymbolIndex    }
                                                                           { neuer Operand wird in Symboltabelle       }
                                                                           { neu eingefgt (Hilfsvariable)             }
    od1string, od2string: string;
    hilfsvar: string;

begin
  od2:= (odk.top as TSymbolElement).Inhalt;
  odk.pop;
  if otk.empty                                                             { d. h. nur noch ein Operand im ODK         }
  then begin
         if Symboltabelle.Symbol(od2)=zahl then invariable:= ''''+Symboltabelle.Symbolstring(od2)+''''  { Konstante    }
                                           else invariable:= Symboltabelle.SymbolString(od2);           { Variable     }
       end
  else begin                                                               { mindestens zwei Operanden im ODK          }
                                                                           { und ein Operator im OTK                   }
         ot:= (otk.top as TSymbolElement).Inhalt;
         otk.pop;
         od1:= (odk.top as TSymbolElement).Inhalt;
         odk.pop;

         hilfsvar:= NextHilfsvariable;                                     { Hilfsvariable erzeugen, auf die das       }
                                                                           { Zwischenergebnis des 3Adress-Formats      }
                                                                           { abgelegt werden kann.  ... dann...        }

         neuerod:= Symboltabelle.SymbolIndex(hilfsvar);                    { diese in der Symboltabelle eintragen      }
                                                                           { ALI-Befehle vorbereiten (Variablen)       }
         If Symboltabelle.Symbol(od1)=zahl then od1string:= ''''+Symboltabelle.Symbolstring(od1)+''''
                                           else od1string:= Symboltabelle.Symbolstring(od1);
         If Symboltabelle.Symbol(od2)=zahl then od2string:= ''''+Symboltabelle.Symbolstring(od2)+''''
                                           else od2string:= Symboltabelle.Symbolstring(od2);
                                                                           { Drei-Adress-Format umsetzen               }
         AliProgramm.add('',LDA,'0,'+od1String,'\');
         Case Symboltabelle.SymbolString(ot)[1] of
           '+': AliProgramm.add('',ADD,'0,'+od2string,' | '+hilfsvar+':='+od1string+'+'+od2string);
           '-': AliProgramm.add('',SUB,'0,'+od2string,' | '+hilfsvar+':='+od1string+'-'+od2string);
           '*': AliProgramm.add('',MUL,'0,'+od2string,' | '+hilfsvar+':='+od1string+'*'+od2string);
           '/': AliProgramm.add('',DIF,'0,'+od2string,' | '+hilfsvar+':='+od1string+'/'+od2string);
           'm': begin                                                      { a mod b = a - (a div b) * b               }
                  AliProgramm.add('',DIF,'0,'+od2string,' | ');
                  AliProgramm.add('',MUL,'0,'+od2string,' | ');
                  AliProgramm.add('',STA,'0,'+hilfsvar,' | '+hilfsvar+':='+od1string+' mod '+od2string);
                  AliProgramm.add('',LDA,'0,'+od1String,' | ');
                  AliProgramm.add('',SUB,'0,'+hilfsvar,' | ');
                end;
         end;
         AliProgramm.add('',STA,'0,'+Symboltabelle.SymbolString(neuerod),'/');
                                                                           { Neuen Operand in den ODK einkellern       }
                                                                           { fr eine sptere Auswertung               }
         odk.push(TSymbolElement.Create(neuerod));

         invariable:= Symboltabelle.SymbolString(neuerod);                 { wre die letzte Hilfsvariable ....        }
                                                                           { hat aber in diesem Zusammenhang           }
                                                                           { keine Bedeutung                           }
       end;
end;


{ Codierer-Routinen .................................................................................................. }


constructor TCoder.create(TL: TTokenliste; var ST: TSymboltabelle);
begin
  inherited create;
  Aliprogramm:= TAliProgramm.Create;
  Tokenliste:= TL;
  Symboltabelle:= ST;
  odk:= TStack.Create;
  otk:= TStack.Create;
end;

destructor TCoder.destroy;
begin
  odk.free;
  otk.free;
  Aliprogramm.free;
  inherited destroy;
end;


  procedure TCoder.S ( var AktuellerTokenIndex: TSymbolIndex ) ;
  var m: string;
      i: integer;
      v: string;
      LastTokenIndex: TSymbolIndex;
  begin {of S, der Startregel}
    AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                       { Programm-Name holen holen                 }
    m:= Symboltabelle.SymbolString(AktuellerTokenIndex);
    Aliprogramm.add(m,'START','0','');
    AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                       { Semikolon holen                           }
    AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                       { begin-Token holen                         }
    BLOCK(AktuellerTokenIndex);
    Aliprogramm.add('','EOJ','','   Ende der Anwweisungen');

    for i:= 1 to maxSymbole do
    begin
      if (Symboltabelle.Symbol(i)=name) and (Symboltabelle.Symbol(i-1)<>nicht_zulaessig)
                                                                           { Token name ist Programmname, wenn         }
                                                                           { Symbol davor nicht_zulaessig ist.         }
      then Aliprogramm.add(Symboltabelle.Symbolstring(i),'DS','F','   zwei Bytes fuer '+Symboltabelle.Symbolstring(i));

    end;
    Aliprogramm.add('','END',m,'   Ende des Programms');                   { Ende des ALI-Programms                    }
  end {of S, der Startregel};

   procedure TCoder.BLOCK (var AktuellerTokenIndex: TSymbolIndex ) ;
   begin {of BLOCK}
     AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                      { zum ersten Token des Befehlsfolge         }
     ANWFOLG(AktuellerTokenIndex);
     AktuellerTokenIndex:= Tokenliste.NextTokenIndex;
   end;

     procedure TCoder.ANWFOLG (var AktuellerTokenIndex: TSymbolIndex ) ;
     begin { of ANWFOLG }
       ANWEISUNG(AktuellerTokenIndex);
       if Symboltabelle.Symbol(AktuellerTokenIndex) = semikolon
       then begin
              AktuellerTokenIndex:= Tokenliste.NextTokenIndex;             { erstes Token von Befehlsfolge holen       }
              ANWFOLG(AktuellerTokenIndex);
            end;
     end; { of ANWFOLG }

       procedure TCoder.ANWEISUNG (var AktuellerTokenIndex: TSymbolIndex ) ;
       begin {of ANWEISUNG}
         case Symboltabelle.Symbol(AktuellerTokenIndex) of
           name:       ZUWEISUNG(aktuellerTokenIndex);
           start:      BLOCK(aktuellerTokenIndex);
           schreib:    SCHREIBANW(aktuellerTokenIndex);
           lies:       LIESANW(aktuellerTokenIndex);
           wenn:       WENNANW(aktuellerTokenIndex);
           wiederhole: WDHANW(aktuellerTokenIndex);
           solange:    SOLANGEANW(aktuellerTokenIndex);
           else      { leere ANWEISUNG }
         end;
       end {of ANWEISUNG};

         procedure TCoder.LIESANW (var AktuellerTokenIndex: TSymbolIndex ) ;
         begin {of LIESANW}
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { klammerauf holen                          }
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { name holen                                }
           Aliprogramm.add('','INI',Symboltabelle.SymbolString(AktuellerTokenIndex),
                           '   readln( '+Symboltabelle.Symbolstring(AktuellerTokenIndex)+')');
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { klammerzu holen                           }
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { und nchsten Befehl vorbereiten           }
         end {of LIESANW};

         procedure TCoder.SCHREIBANW (var AktuellerTokenIndex: TSymbolIndex ) ;
         var ausgabevariable: string;
         begin {of SCHREIBANW}
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { klammerauf holen                          }
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { erstes Token von AUSDRUCK holen           }

           AUSDRUCK(AktuellerTokenIndex, ausgabevariable);
           while not odk.empty do Werte_aus(ausgabevariable);              { hier muss der ODK solange ausgewertet     }
                                                                           { werden, bis kein Operand mehr im ODK      }
                                                                           { ist. Verbesserungsbedrftig!              }
           Aliprogramm.add('','OUTI',ausgabevariable,'   writeln( '+ausgabevariable+')');
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { klammerzu holen                           }
         end {of SCHREIBANW};

         procedure TCoder.WDHANW (var AktuellerTokenIndex: TSymbolIndex ) ;
         var Marke: string;
         begin {of WDHANW}
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                {erstes Token von ANWEISUNG holen           }

           Marke:= NextSprungmarke;                                        { Neue Sprungmarke erzeugen                 }
           Aliprogramm.add(Marke,'NOP','','   WHILE-Schleifenanfang');     { und als Schleifenanfang setzen            }
           ANWFOLG(AktuellerTokenIndex);                                   { dann die ANWEISUNGsfolge abarbeiten       }
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { dann erstes Token vom BEDAUSDR            }

           BEDAUSDR(AktuellerTokenIndex, Marke, false);                    { und Aufruf von BEDAUSDR ....              }
                                                                           { der bedingte Sprung wird in BEDAUSDR      }
                                                                           { ausgefhrt. Die "Marke" ist die Stelle,   }
                                                                           { wohin gesprungen wird, der CBV-Paramter   }
                                                                           { false bewirkt, dass die invertierte       }
                                                                           { Bedingung betrachtet wird.                }
                                                                           { wenn BEDAUSDR = false, dann goto Marke    }
         end; {of WDHANW}

         procedure TCoder.SOLANGEANW (var AktuellerTokenIndex: TSymbolIndex ) ;
         var Markeloop, Markeweiter: string;
         begin {of SOLANGEANW}
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { erstes Token von BEDAUSDR holen           }
           Markeloop:= NextSprungmarke;                                    { neue Sprungmarke erzeugen                 }
           Aliprogramm.add(Markeloop,'NOP','','   REPEAT-Schleifenanfang');
                                                                           { und als Schleifenkopf in ALI-Programm     }

           Markeweiter:= NextSprungmarke;                                  { neue Sprungmarke fr Schleifen-Ende       }

           BEDAUSDR(AktuellerTokenIndex, Markeweiter,false);               { jetzt der bedingte Sprung ans Schlei-     }
                                                                           { fenende, falls der BEDAUSDR=false         }

           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { erstes Token von ANWEISUNG holen          }

           ANWEISUNG(AktuellerTokenIndex);                                 { und ANWEISUNG abarbeiten                  }
           Aliprogramm.add('','B',Markeloop,'   Sprung zum Anfang der REPEAT-Schleife');
                                                                           { schlielich Sprung zum Schleifenanfang    }
           Aliprogramm.add(Markeweiter,'NOP','','   Sprungmarke fuer Ausstieg aus REPEAT-Schleife');
                                                                           { und Schleifen-Ausstiegs-Marke             }

         end; {of SOLANGEANW}

         procedure TCoder.WENNANW (var AktuellerTokenIndex: TSymbolIndex ) ;
         var WeiTERMarke, Sonstmarke: string;
         begin {of wennanw}
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { Start des BEDAUSDRs holen                 }
           Sonstmarke:= NextSprungmarke;                                   { Marke fr den evtl. ELSE-Zweig            }

           BEDAUSDR(AktuellerTokenIndex,Sonstmarke, false);                { false heisst invertierte Bedingung        }

           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { Start der ANWEISUNG holen                 }
           ANWEISUNG(AktuellerTokenIndex);                                 { und abarbeiten                            }

           if Symboltabelle.Symbol(AktuellerTokenIndex)=sonst              { kommt ein ELSE-Zweig?                     }
           then begin
                  WeiTERMarke:= NextSprungmarke;                           { Marke fr das berspringen des            }
                                                                           { ELSE-Teils nach dem Then-Zweig            }
                  Aliprogramm.add('','B',Weitermarke,'   ELSE-Teil-Ueberspringen');
                                                                           { und diese ins ALI-Prg einbauen            }
                  Aliprogramm.add(Sonstmarke,'NOP','','   ELSE-Teil-Anfang');
                                                                           { und Einsprungmarke fr den ELSE-Zweig     }
                  AktuellerTokenIndex:= Tokenliste.NextTokenIndex;         { Start der nchsten ELSE-ANWEISUNG         }
                  ANWEISUNG(AktuellerTokenIndex);                          { und diese abarbeiten                      }
                  Aliprogramm.add(WeiTERMarke,'NOP','','   Ende der IF-THEN-ELSE-Anweisung');
                                                                           { Ausstiegsmarke fr den THEN-Zweig         }
                end
           else begin
                  Aliprogramm.add(Sonstmarke,'NOP','','   Ende der IF-THEN-Anweisung');
                                                                           { ansonsten (kein ELSE) nur                 }
                                                                           { die bersprung-Marke in ALI-Prg einfgen  }
                end;
         end; {of wennanw}

           procedure TCoder.BEDAUSDR (var AktuellerTokenIndex: TSymbolIndex; Smarke: string; Test_auf: boolean ) ;
           var Marke: string;
           begin { of bedausruck }
             if Test_auf = false                                           { muss Bedingung invertiert werden?         }
             then begin                                                    { dann muss jede Bedingung fr sich         }
                                                                           { auf true berprft werden.                }
                                                                           { ---> DeMorgansche Gesetze <---            }
                    Marke:= NextSprungmarke;
                    BEDTERM(AktuellerTokenIndex,Marke,true);
                    while (Symboltabelle.Symbol(AktuellerTokenIndex)=oder)
                                                                           { gibts noch ein oder-Teil?                 }
                    do begin
                        AktuellerTokenIndex:= Tokenliste.NextTokenIndex;   { Nchstes Token vom BEDTERM holen          }
                        BEDTERM(AktuellerTokenIndex, Marke, true);
                       end;
                    Aliprogramm.add('','B',SMarke,'');
                    Aliprogramm.add(Marke,'NOP','','');
                  end
             else begin                                                    { sonst muss jede Bedingung fr sich        }
                                                                           { auf false berprft werden, um            }
                                                                           { auszusteigen.                             }
                    BEDTERM(AktuellerTokenIndex, SMarke, false);
                    while (Symboltabelle.Symbol(AktuellerTokenIndex)=oder)
                                                                           { gibts noch ein oder-Teil?                 }
                    do begin
                        AktuellerTokenIndex:= Tokenliste.NextTokenIndex;   { Nchstes Token vom BEDTERM holen          }
                        BEDTERM(AktuellerTokenIndex, SMarke, false);
                       end;

                  end;
           end;  { of bedausruck }

             procedure TCoder.BEDTERM (var AktuellerTokenIndex: TSymbolIndex; Smarke: string; Test_auf: boolean ) ;
             var Marke: string;
             begin { of BEDTERM }
               if Test_auf = true                                          { muss Bedingung invertiert werden?         }
                                                                           { dann muss jede Bedingung fr sich         }
                                                                           { auf true berprft werden.                }
                                                                           { ---> DeMorgansche Gesetze <---            }
               then begin
                      Marke:= NextSprungmarke;
                      VERGLEICH(AktuellerTokenIndex,Marke,false);
                      while (Symboltabelle.Symbol(AktuellerTokenIndex)=und)
                      do begin
                          AktuellerTokenIndex:= Tokenliste.NextTokenIndex; { Nchstes Token vom VERGLEICH holen        }
                          VERGLEICH(AktuellerTokenIndex, Marke, false);
                         end;
                      Aliprogramm.add('','B',SMarke,'');
                      Aliprogramm.add(Marke,'NOP','','');
                    end
               else begin
                      VERGLEICH(AktuellerTokenIndex, SMarke, true);
                      while (Symboltabelle.Symbol(AktuellerTokenIndex)=und)
                      do begin
                          AktuellerTokenIndex:= Tokenliste.NextTokenIndex; { Nchstes Token vom VERGLEICH holen        }
                          VERGLEICH(AktuellerTokenIndex, SMarke, true);
                         end;

                    end;
             end;  { of BEDTERM }


               procedure TCoder.VERGLEICH (var AktuellerTokenIndex: TSymbolIndex; Smarke: string; Test_auf: boolean) ;
               var opd1, opd2, opt: string;
                   AliOpt: string;

               begin { of VERGLEICH }
                 AUSDRUCK(AktuellerTokenIndex, opd1);                      { AUSDRUCK auswewrten                       }
                 while not odk.empty do Werte_aus(opd1);

                 opt:= Symboltabelle.Symbolstring(AktuellerTokenIndex);

                 AktuellerTokenIndex:= Tokenliste.NextTokenIndex;          { erstes Token vom zweiten AUSDRUCK holen   }

                 AUSDRUCK(AktuellerTokenIndex,opd2);                       { zweiten AUSDRUCK auswewrten               }
                 while not odk.empty do Werte_aus(opd2);

                 if opt='='  then begin
                                    if Test_auf=false then AliOpt:= 'BNE'  { wenn Test_auf = false ist, so muss die    }
                                                                           { invertierte Bedingung getestet werden     }
                                                      else AliOpt:= 'BE';  { sonst muss die Bedingung getestet werden  }
                                  end;
                 if opt='<>' then begin
                                    if Test_auf=false then AliOpt:= 'BE'
                                                      else AliOpt:= 'BNE';
                                  end;
                 if opt='<'  then begin
                                    if Test_auf=false then AliOpt:= 'BNL'
                                                      else AliOpt:= 'BL';
                                  end;
                 if opt='>'  then begin
                                    if Test_auf=false then AliOpt:= 'BNH'
                                                      else AliOpt:= 'BH';
                                  end;
                 if opt='<=' then begin
                                    if Test_auf=false then AliOpt:= 'BH'
                                                      else AliOpt:= 'BNH';
                                  end;
                 if opt='>=' then begin
                                    if Test_auf=false then AliOpt:= 'BL'
                                                      else AliOpt:= 'BNL';
                                  end;

                 Aliprogramm.add('',LDA,'0,'+opd1,'\');
                 if Test_auf = true
                 then Aliprogramm.add('',CMP,'0,'+opd2,' | if '+opd1+opt+opd2+' then goto '+smarke)
                 else Aliprogramm.add('',CMP,'0,'+opd2,' | if not('+opd1+opt+opd2+') then goto '+smarke);
                 Aliprogramm.add('',AliOpt,Smarke,'/');

               end; { of VERGLEICH }

         procedure TCoder.ZUWEISUNG (var AktuellerTokenIndex: TSymbolIndex ) ;
         var invariable: string;
             outvariable: string;
         begin {of ZUWEISUNG}

           outvariable:= Symboltabelle.SymbolString(AktuellerTokenIndex);
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { Zuwweisungsoperator (:=) holen            }
           AktuellerTokenIndex:= Tokenliste.NextTokenIndex;                { ersten Operand von AUSDRUCK holen         }

           AUSDRUCK(AktuellerTokenIndex, invariable);
           while not odk.empty do Werte_aus(invariable);                   { anschlieende ODK-Auswertung              }

           Aliprogramm.add('',LDA,'0,'+invariable,'   '+outvariable+' := '+invariable);
                                                                           { und in ALI-Programm einfgen              }
           Aliprogramm.add('',STA,'0,'+outvariable,'');

         end {of ZUWEISUNG};

          procedure TCoder.AUSDRUCK (var AktuellerTokenIndex: TSymbolIndex; var invariable: string) ;
          begin { of AUSDRUCK }
            TERM(AktuellerTokenIndex, invariable);                         { erst den TERM analysieren                 }
            if Symboltabelle.Symbol(AktuellerTokenIndex) = strichoperator  { wenn ein +/- kommt, so muss dieses        }
            then begin                                                     { evtl. im OTK- eingekellert werden         }
                   if not otk.empty                                        { um es erst spter auszuwerten             }
                   then begin
                          if Prioritaet(Symboltabelle.Symbol(AktuellerTokenIndex))<=
                             Prioritaet(Symboltabelle.Symbol((otk.top as TSymbolElement).Inhalt))
                          then Werte_aus(invariable);
                        end;
                   otk.push(TSymbolElement.Create(AktuellerTokenIndex));

                   AktuellerTokenIndex:= Tokenliste.NextTokenIndex;
                   AUSDRUCK(AktuellerTokenIndex, invariable);              { und Rekursionsaufruf                      }
                 end;

          end; { of audruck }

           procedure TCoder.TERM (var AktuellerTokenIndex: TSymbolIndex; var invariable: string) ;
           begin {of TERM}
             FAKTOR(AktuellerTokenIndex, invariable);                      { wie bei AUSDRUCK                          }
             if Symboltabelle.Symbol(AktuellerTokenIndex) = punktoperator
             then begin
                    if not otk.empty
                    then begin
                           if Prioritaet(Symboltabelle.Symbol(AktuellerTokenIndex))<=
                              Prioritaet(Symboltabelle.Symbol((otk.top as TSymbolElement).Inhalt))
                           then Werte_aus(invariable);
                         end;
                    otk.push(TSymbolElement.Create(AktuellerTokenIndex));

                    AktuellerTokenIndex:= Tokenliste.NextTokenIndex;
                    TERM(AktuellerTokenIndex, invariable);
                  end
           end {of TERM};

            procedure TCoder.FAKTOR (var AktuellerTokenIndex: TSymbolIndex; var invariable: string) ;
            begin
              if Symboltabelle.Symbol(AktuellerTokenIndex) = klammerauf
              then begin
                     otk.push(TSymbolElement.Create(AktuellerTokenIndex));
                     AktuellerTokenIndex:= Tokenliste.NextTokenIndex;      { ersten Operand von AUSDRUCK holen         }
                     AUSDRUCK(AktuellerTokenIndex,invariable);
                     AktuellerTokenIndex:= Tokenliste.NextTokenIndex;      { Klammerzu holen                           }

                     repeat
                       Werte_Aus(invariable);
                     until Symboltabelle.Symbol((otk.top as TSymbolElement).Inhalt)=klammerauf;
                     otk.pop;
                   end
              else begin
                     odk.push(TSymbolElement.Create(AktuellerTokenIndex));
                     AktuellerTokenIndex:= Tokenliste.NextTokenIndex;
                   end
            end;


procedure TCoder.Code;
var AktuellerTokenIndex: TSymbolIndex;
begin
  Hcounter:= 0;
  Mcounter:= 0;
  AktuellerTokenIndex:= Tokenliste.NextTokenIndex;
  S (AktuellerTokenIndex);
end;

end.



