{ UNIT Vereinigung aller Compilerschritte ............................................................. <COMPILER.PAS> }
{                                                                                                                      }
{ diese beinhaltet:                                                                                                    }
{      ... Symboltabelle: eine Tabelle, die alle vordefinierten und vom User im aktuellen Programm definierten Symbole }
{                         enthlt. D.h. auch alle genannten variablen und Zahlen! Die Eintrge bestehen aus:           }
{                                                                                                                      }
{                               Zeichenkette und Symbol                                                                }
{                                                                                                                      }
{                         "Symbol" ist ein Synomym fr "Token"!                                                        }
{                                                                                                                      }
{      ... Tokenliste   : eine Liste als Abbild des aktuellen Programms, wobei der Programmtext als eine Folge von     }
{                         Indizes dargestellt wird, die sich auf die entsprechenden Informationen der Symboltabelle    }
{                         beziehen!                                                                                    }
{                                                                                                                      }
{      ... Scanner      : Der Scannerautomat mit seiner wichtigsten Methode "Scan" zum scannen eines Quelltextes. Die  }
{                         Tokenliste und Symboltabelle wird vom Scanner mit Inhalt gefllt.                            }
{                                                                                                                      }
{      ... Parser       : Der Top-Down-Parser mit seiner wichtigsten Methode "Parse" zum parsen eines Quelltextes.     }
{                         Die Klasse nimmt (nur lesenden) Bezug auf die Tokenliste. Die Symboltabelle bleibt unberhrt.}
{                                                                                                                      }
{      ... Coder        : Der Codierer mit seiner wichtigsten Methode "code" codiert den Quelltext in Assembler-Code.  }
{                         Da neue Hilfsvariablen bei der Erzeugung des Zwischencodes (RePas) bentigt werden, mssen   }
{                         diese in der Symboltabelle abgelegt werden. Die Tokenliste bleibt unverndert, wird aber zum }
{                         erstellen des Codes bentigt.                                                                }
{                                                                                                                      }
{                                                                                                                      }
{                                                                                       Version 5 / 2002 / Ga / Lk12.2 }
{ -------------------------------------------------------------------------------------------------------------------- }

unit Compiler;

interface

uses u_types, Scanner, Parser, Coder;

type
     TCompiler = class
       public
       Tokenliste: TTokenliste;                                    { Die Tokenliste als Ableitung von TLinList         }
       Symboltabelle: TSymboltabelle;                              { Klasse mit einem Array als Speicheurng            }

       Scanner: TScanner;                                          { Der Scanner                                       }
       Parser: TParser;                                            { Der Parser                                        }
       Coder: TCoder;                                              { Der Codierer in ALI                               }

       constructor create;
       destructor destroy;

     end;

implementation

{ ------------------     Routinen fr den Compiler    ---------------------------------------------------------------- }

constructor TCompiler.Create;
begin
  Symboltabelle:= TSymboltabelle.Create;
  Tokenliste:= TTokenliste.Create(Symboltabelle);                  { braucht die Symboltabelle (lesend)                }
  Scanner:= TScanner.Create(Tokenliste, Symboltabelle);            { braucht Symboltabelle und Tokenliste (schreibend) }
  Parser:= TParser.Create(Tokenliste);                             { braucht Tokenliste (lesend)                       }
  Coder:= TCoder.Create(Tokenliste, Symboltabelle);                { braucht Tokenliste (lesend) und Symboltab.(schr.) }
end;

destructor TCompiler.Destroy;
begin
  Tokenliste.Free;
  Symboltabelle.Free;
  Scanner.Free;
  Parser.Free;
  Coder.Free;
end;

end.
