{ UNIT zur Gewinnung der tokenliste und Symboltabelle aus dem jeweils vorliegenden Textfile. ........... <SCANNER.PAS> }
{                                                                                                                      }
{ Symboltabelle und Tokenliste werden vom Objekt TCompiler bereitgestellt.                                             }
{                                                                                                                      }
{ Der zugrunde liegende Scanner-Automat: ............................................................................. }
{                                                                                                                      }
{                                            +----+    > =                                                             }
{                                            | S7 |------------+                                                       }
{                +--+                        +----+            |                                                       }
{                |  | a..z, A..Z, 0..9, _      A               |                                                       }
{                |  V                          | <             |                                                       }
{               +----+  a..z, A..Z             |               |                                                       }
{               | S5 |<----+   +---------------+               |                                                       }
{               +----+     |   |           +----+      =       |                                                       }
{                          |   |   > +-----| S8 |--------------+                                                       }
{         +----+   0..9   +----+-----+     +----+              V                                                       }
{    +--> | S4 | <------- | S0 |     :     +----+    =      +----+                                                     }
{    |    +----+      +-- +----+ --------> | S1 |---------> | S2 |                                                     }
{    |     |  A 0..9  |    |  A \          +----+           +----+                                                     }
{0..9|     |  |       |    |  |  \                         _                                                           }
{    |     +--+       |    +--+   \________________________/|                                                          }
{    +--- +----+ <----+     #10              ().*/;=                                                                   }
{         | S3 |   +,-      #13                                                                                        }
{         +----+            #32                                                                                        }
{                                                                                                                      }
{ .................................................................................................................... }
{                                                                                                                      }
{                                                                                       Version 5 / 2002 / Ga / Lk12.2 }
{ -------------------------------------------------------------------------------------------------------------------- }


unit Scanner;

 interface

   uses   u_types, u_adt;

   type   TScanner = class                                                 { Scanner realisiert als Klasse             }
            private
            Symboltabelle: TSymboltabelle;                                 { da Symboltabelle und Tokenlist Klassen    }
            Tokenliste: TTokenListe;                                       { sind, wird auf den im Konstruktor ber-   }
                                                                           { gebenen Klassen operiert.                 }
            public
            constructor create(TL: TTokenliste; ST: TSymboltabelle);       { "Zeiger" auf Tokenliste und Symboltabelle }

            function Scan ( var Quelltext: textfile): Byte ;               { Quelltext-Scanmit mit Rckgabe FehlerNr.  }
            function Fehlermeldung_Scanner(FehlerNr: Byte): string;        { Entschlsslung der FehlerNr.              }
          end;


 implementation

{ ------------------     Routinen fr den Scanner    ----------------------------------------------------------------- }

constructor TScanner.Create(TL: TTokenliste; ST: TSymboltabelle);
begin
  Tokenliste:= TL;                                                         { Da TL und ST Zeiger sind, wird auf den    }
  Symboltabelle:= ST;                                                      { Ursprungsdaten operiert.                  }
end;


function TScanner.Scan ( var Quelltext: textfile): Byte ;                  { Mit dem oben angezeigten Scannerautomat   }
var Ablage    : Char;
    FehlerNr  :  Byte;

   procedure ScanSymbol( var Quelltext : textfile;
                         var FehlerNr  : Byte;
                         var Ablage    : char);

    type TZustaende =(s0,s1,s2,s3,s4,s5,s6,s7,s8);

    var Zustand        : tZustaende;
        Endzustand     : Boolean;
        Zeichen        : char;
        Zeichenkette   : String;
        SymbolIndex    : TSymbolIndex;

    procedure ScanChar ( var Quelltext: textfile;
                         var Zeichen, Ablage :char );
     begin
       if Ablage = #255                                                    { es liegt kein altes Zeichen vor           }
       then begin
              if not eof(Quelltext)
              then Read(Quelltext,Zeichen);
            end
       else begin
              Zeichen := Ablage;                                           { es lag ein altes Zeichen vor              }
              Ablage  := #255;
            end;
     end;

    begin { of ScanSymbol }
      Zustand:= s0;
      Endzustand:= False;
      Zeichenkette:= '';
      repeat
        ScanChar(quelltext,zeichen,ablage);
        if Zeichen <> #255                                                 { Es gibt ein nchstes Zeichen              }
        then begin
               Zeichenkette:= Zeichenkette + Zeichen;
               case Zustand of
                 s0: case Zeichen of
                       ' ',#10,#13: begin
                                      zustand:= s0;
                                      Zeichenkette:= '';
                                    end;
                       '(', ')',
                       '.', '*',
                       '/', ';',
                       '='        : zustand:= s2;
                       ':'        : zustand:= s1;
                       '+','-'    : zustand:= s3;
                       '0'..'9'   : zustand:= s4;
                       'a'..'z',
                       'A'..'Z'   : zustand:= s5;
                       '{'        : zustand:= s6;
                       '<'        : zustand:= s7;
                       '>'        : zustand:= s8;
                       else FehlerNr := 1;
                     end {Of Case};
                 s1: begin
                       if Zeichen = '=' then Zustand:= s2                  { := erkannt                                }
                                        else FehlerNr := 1;                { nur : ist kein gltiges Token             }
                     end;
                 s2: endzustand:= true;                                    { Endzustand fr Sonderzeichen              }
                 s3: if Zeichen in Ziffern
                       then Zustand:= s4                                   { vorzeichenbehaftete Zahl                  }
                       else Endzustand:= True;                             { oder Operator                             }
                 s4: if not (Zeichen in Ziffern)
                     then Endzustand:= True;                               { Ziffernfolge abgeschlossen, Zahl erkannt  }
                 s5: if not (Zeichen in (Buchstaben + Ziffern))
                     then Endzustand:= True;                               { Buchstabenfolge abgeschlossen, Bez. erk.  }
                 s6: if Zeichen= '}'                                       { Ende des Kommentarblocks                  }
                     then begin
                            Zeichenkette:= '';
                            Zustand:= s0;
                          end;
                 s7: if Zeichen in ['=','>']
                     then Zustand:= s2                                     { <= und <> erkannt                         }
                     else Endzustand:= true;                               { < erkannt und letztes Zeichen sichern     }
                 s8: if Zeichen = '='
                     then Zustand:= s2                                     { >= erkannt                                }
                     else Endzustand:= true;                               { > erkannt und letztes Zeichen sichern     }
               end {OF CASE};
             end { ein zeichen lag vor }
      until (FehlerNr > 0) or endzustand or (zeichen = #255) or (eof(Quelltext) and (Ablage=#255));

      if endzustand                                                        { Wenn ein Endzustand erreicht ist, dann    }
      then begin                                                           { wird das letzte unntig angehngte Zeichen}
             delete (Zeichenkette, Length(Zeichenkette),1);                { wieder gelscht.                          }
             Ablage := Zeichen;
           end;

      if not (eof(Quelltext) and (Zeichenkette=''))                        { Ist noch Quelltext zu scannen?            }
      then begin
             if FehlerNr > 0                                               { Fehler => Fehlertoken in Tokenliste einf. }
               then begin
                      Zeichenkette:= '??';                                 { Zugriff auf das Fehlertoken !             }
                      Symbolindex:= Symboltabelle.SymbolIndex(Zeichenkette);
                      Tokenliste.EinfuegenNach ( TSymbolElement.Create(SymbolIndex));
                    end
               else begin                                                  { akzeptierte Zeichenkette                  }
                      if Length (Zeichenkette) > maxBezeichnerLaenge
                         then Delete (Zeichenkette, maxBezeichnerLaenge+1, Length(Zeichenkette)-maxBezeichnerLaenge);
                       SymbolIndex:= Symboltabelle.Symbolindex(Zeichenkette);
                       if SymbolIndex = 0                                  { die Symboltabelle war schon voll!         }
                       then FehlerNr:= 2
                       else Tokenliste.EinfuegenNach(TSymbolElement.Create( SymbolIndex ));
                     end;
           end;
    end; { of lies_naechstes_symbol }

begin { of scan }
  Ablage:= #255;
  FehlerNr:= 0;
  repeat
    ScanSymbol(Quelltext, FehlerNr, ablage);
  until (eof(Quelltext) and (Ablage=#255)) or (FehlerNr > 0);
  Scan:= FehlerNr;
end; { of scan }



function TScanner.Fehlermeldung_Scanner(FehlerNr: Byte): string;
begin
  case FehlerNr of
    0: Fehlermeldung_Scanner:= 'Scanprozess erfolgreich!';
    1: Fehlermeldung_Scanner:= 'Syntaxfehler! Zeichen unbekannt!';
    2: Fehlermeldung_Scanner:= 'Zuviele Bezeichner verwendet!';
  end;
end;

 end.
